/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Annotations.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Annotations extends GenericJson {

  /**
   * A list of annotations.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Annotation> items;

  static {
    // hack to force ProGuard to consider Annotation used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Annotation.class);
  }

  /**
   * Resource type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Token to pass in for pagination for the next page. This will not be present if this request
   * does not have more results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String nextPageToken;

  /**
   * Total number of annotations found. This may be greater than the number of notes returned in
   * this response if results have been paginated.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer totalItems;

  /**
   * A list of annotations.
   * The value returned may be {@code null}.
   */
  public java.util.List<Annotation> getItems() {
    return items;
  }

  /**
   * A list of annotations.
   * The value set may be {@code null}.
   */
  public Annotations setItems(java.util.List<Annotation> items) {
    this.items = items;
    return this;
  }

  /**
   * Resource type.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Resource type.
   * The value set may be {@code null}.
   */
  public Annotations setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Token to pass in for pagination for the next page. This will not be present if this request
   * does not have more results.
   * The value returned may be {@code null}.
   */
  public String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token to pass in for pagination for the next page. This will not be present if this request
   * does not have more results.
   * The value set may be {@code null}.
   */
  public Annotations setNextPageToken(String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * Total number of annotations found. This may be greater than the number of notes returned in
   * this response if results have been paginated.
   * The value returned may be {@code null}.
   */
  public Integer getTotalItems() {
    return totalItems;
  }

  /**
   * Total number of annotations found. This may be greater than the number of notes returned in
   * this response if results have been paginated.
   * The value set may be {@code null}.
   */
  public Annotations setTotalItems(Integer totalItems) {
    this.totalItems = totalItems;
    return this;
  }

}
