/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Model definition for AnnotationsSummary.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AnnotationsSummary extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Layers> layers;

  static {
    // hack to force ProGuard to consider Layers used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Layers.class);
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**

   * The value set may be {@code null}.
   */
  public AnnotationsSummary setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public java.util.List<Layers> getLayers() {
    return layers;
  }

  /**

   * The value set may be {@code null}.
   */
  public AnnotationsSummary setLayers(java.util.List<Layers> layers) {
    this.layers = layers;
    return this;
  }

  /**
   * Model definition for AnnotationsSummaryLayers.
   */
  public static final class Layers extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer allowedCharacterCount;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String layerId;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String limitType;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer remainingCharacterCount;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private DateTime updated;

    /**

     * The value returned may be {@code null}.
     */
    public Integer getAllowedCharacterCount() {
      return allowedCharacterCount;
    }

    /**

     * The value set may be {@code null}.
     */
    public Layers setAllowedCharacterCount(Integer allowedCharacterCount) {
      this.allowedCharacterCount = allowedCharacterCount;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getLayerId() {
      return layerId;
    }

    /**

     * The value set may be {@code null}.
     */
    public Layers setLayerId(String layerId) {
      this.layerId = layerId;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getLimitType() {
      return limitType;
    }

    /**

     * The value set may be {@code null}.
     */
    public Layers setLimitType(String limitType) {
      this.limitType = limitType;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Integer getRemainingCharacterCount() {
      return remainingCharacterCount;
    }

    /**

     * The value set may be {@code null}.
     */
    public Layers setRemainingCharacterCount(Integer remainingCharacterCount) {
      this.remainingCharacterCount = remainingCharacterCount;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public DateTime getUpdated() {
      return updated;
    }

    /**

     * The value set may be {@code null}.
     */
    public Layers setUpdated(DateTime updated) {
      this.updated = updated;
      return this;
    }

  }

}
